﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamGridProb
{
    public class zumFilterObject : INotifyPropertyChanged
    {

        #region Fields
        private RangeEnabledObservableCollection<ClientzumDto> _zumList;
        private ClientzumDto _activezum;
        #endregion Fields

        #region Properties
        


        public RangeEnabledObservableCollection<ClientzumDto> zumList
        {
            get { return _zumList; }
            set
            {
                _zumList = value;
                OnPropertyChanged("zumList");
            }
        }

        public ClientzumDto Activezum
        {
            get { return _activezum; }
            set
            {
                _activezum = value;

                OnPropertyChanged("Activezum");
            }
        }


        #endregion Properties

        #region Constructor

        // TODO: rdf - Konstruktor überarbeiten!

        public zumFilterObject()
        {
           
            InitializeData(null);
        }


        #endregion Constructor
        #region Commands



        #endregion Commands

        #region Public Methods
        public void Addzum()
        {
            zumList.Insert(0, new ClientzumDto());
        }
   
        #endregion Public Methods

        #region Internal Methods
        #endregion Internal Methods

        #region Protected Methods
        #endregion Protected Methods

        #region Private Methods

        

        private void InitializeData(ClientzumDto activezum)
        {
            zumList = new RangeEnabledObservableCollection<ClientzumDto>
                {
                    new ClientzumDto()
                };
     
            zumList[0].Conditions.Add(new ClientzumCondition());
            Activezum = zumList[0];
        }



        #endregion Private Methods


        protected void OnPropertyChanged(string propertyName)
        {
#if DEBUG
            //damit nicht immer im CurrentTime PropertyChanged angehalten wird
            if (propertyName != "CurrentTime")
                propertyName = propertyName;
#endif
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }


        public event PropertyChangedEventHandler PropertyChanged;
    }


    public class RangeEnabledObservableCollection<T> : ObservableCollection<T>
    {
        #region Dependency Properties
        #endregion Dependency Properties

        #region Fields
        #endregion Fields

        #region Properties
        #endregion Properties

        #region Constructor
        public RangeEnabledObservableCollection()
            : base()
        {

        }
        public RangeEnabledObservableCollection(IEnumerable<T> collection)
            : base(collection)
        {

        }
        public RangeEnabledObservableCollection(List<T> collection)
            : base(collection)
        {

        }
        #endregion Constructor

        #region Public Methods
        public void AddRange(IEnumerable<T> items)
        {
            this.CheckReentrancy();
            if (items == null)
                return;

            var newItems = items.ToList();

            for (int i = 0; i < newItems.Count; i++)
                this.Items.Add(newItems[i]);

            this.OnCollectionChanged(new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Add, newItems));
        }

        public void AddRange(IEnumerable items)
        {
            AddRange(items as IEnumerable<T>);
        }
        #endregion Public Methods

        #region Internal Methods
        #endregion Internal Methods

        #region Protected Methods
        #endregion Protected Methods

        #region Private Methods
        #endregion Private Methods
    }
}
